unit Unit21;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.TMSFNCTypes, FMX.TMSFNCUtils, FMX.TMSFNCGraphics,
  FMX.TMSFNCGraphicsTypes, FMX.Controls.Presentation, FMX.StdCtrls, FMX.Layouts, FMX.TMSFNCCustomControl, FMX.TMSFNCWebBrowser,
  FMX.TMSFNCMaps, FMX.TMSFNCGoogleMaps, FMX.TMSFNCMapsCommonTypes,
  Math;

type
  TForm21 = class(TForm)
    Map: TTMSFNCGoogleMaps;
    Layout2: TLayout;
    bnMarker: TButton;
    Timer1: TTimer;
    lbNumPolylines: TLabel;
    procedure MapMapInitialized(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bnMarkerClick(Sender: TObject);
  private
    { Private declarations }
    fCurrentPositionMarker: TTMSFNCGoogleMapsMarker;
    fPreviousLatitude: double;
    fPreviousLongitude: double;
  public
    { Public declarations }
  end;

var
  Form21: TForm21;

implementation

{$R *.fmx}

procedure TForm21.bnMarkerClick(Sender: TObject);
var
  vMarker: TTMSFNCGoogleMapsMarker;
begin
  // add a Marker to the current position
  Map.BeginUpdate;
    vMarker := Map.Markers.Add;
    vMarker.Latitude := fCurrentPositionMarker.Latitude;
    vMarker.Longitude := fCurrentPositionMarker.Longitude;
  Map.EndUpdate;
end;

procedure TForm21.MapMapInitialized(Sender: TObject);
begin
  Timer1.Enabled := true;

  fPreviousLatitude := Map.Options.DefaultLatitude;
  fPreviousLongitude := Map.Options.DefaultLongitude;

  Map.BeginUpdate;
    fCurrentPositionMarker := Map.Markers.Add;
    fCurrentPositionMarker.Latitude := Map.Options.DefaultLatitude;
    fCurrentPositionMarker.Longitude := Map.Options.DefaultLongitude;
  Map.EndUpdate;
end;

procedure NextCoords(aStartLat, aStartLon: double; var aEndLat, aEndLon: double);
begin
  aEndLat := aStartLat + 0.0001;
  aEndLon := aStartLon + 0.0001;
end;

procedure TForm21.Timer1Timer(Sender: TObject);
var
  vLat, vLon: double;
  vPolyline: TTMSFNCMapsPolyline;
  vArray: TTMSFNCMapsCoordinateRecArray;
begin
  // calculate next coordinates
  NextCoords(fCurrentPositionMarker.Latitude, fCurrentPositionMarker.Longitude, vLat, vLon);

  fCurrentPositionMarker.Latitude := vLat;
  fCurrentPositionMarker.Longitude := vLon;

  Map.BeginUpdate;
    // add a polyline segment
    SetLength(vArray, 2);
    vArray[0] := CreateCoordinate(fPreviousLatitude, fPreviousLongitude);
    vArray[1] := CreateCoordinate(fCurrentPositionMarker.Latitude, fCurrentPositionMarker.Longitude);

    vPolyline := Map.AddPolyline(vArray);
    vPolyline.StrokeColor := Random($FFFFFFFF);
    vPolyline.StrokeWidth := 5;
    vPolyline.StrokeOpacity := 1;
  Map.EndUpdate;

  fPreviousLatitude := vLat;
  fPreviousLongitude := vLon;

  lbNumPolylines.Text := Map.Polylines.Count.ToString;
end;


end.
